<?php
/**
 * @package IWP-Helper
 * @version 1.0
 */
/*
Plugin Name: IWP Helper
Description: It will add this WP site to your IWP Admin Panel. 
Version: 1.0
Author: Revmakx
Author URI: http://infinitewp.com/
*/


@include_once(ABSPATH . 'wp-admin/includes/file.php');
@include_once(ABSPATH . 'wp-admin/includes/plugin.php');

define("PANELURL", "https://replace-your-iwp-panel-url-here/quickAdd.php"); // Replace with panel URL.
function iwp_client_helper_add_panel(){
	if(is_admin()){
		$plugin = "iwp-client/init.php";
		
		if(is_plugin_active($plugin) && !isSiteConnected()){
			addPanelProcessor();
		}
		elseif(file_exists(ABSPATH."/wp-content/plugins/iwp-client/init.php") && !is_plugin_active($plugin)){
			$result = activate_plugin($plugin);
			addPanelProcessor();
			deactivate_plugins(array("iwp-helper/iwp-helper.php"));
		delete_plugins(array("iwp-helper/iwp-helper.php"));
		echo "<script> window.location='plugins.php'; </script>";

		}
		elseif(!is_plugin_active($plugin) && !file_exists(ABSPATH."/wp-content/plugins/iwp-client/init.php")){
			//install plugin and activate here.
			$requestParams = array('package' => array("http://downloads.wordpress.org/plugin/iwp-client.zip"), 'activate' => true);
			    ob_start();
						$insallClientPlugin = insallClientPlugin($requestParams);
						   ob_end_clean();
						echo "<script> window.location='plugins.php'; </script>";
		}
		else{
			$i = true;
		}
		
	//	deactivate_plugins(array("iwp-helper/iwp-helper.php"));
		//delete_plugins(array("iwp-helper/iwp-helper.php"));
		
		return true;
	}
}

//add_action( 'admin_init', 'iwp_client_helper_add_panel');
add_action( 'admin_notices', 'iwp_client_helper_add_panel');

function isSiteConnected(){
	$clientPublicKey = get_option( 'iwp_client_public_key' );
	if(!empty($clientPublicKey)){
		return true;
	}
	return false;
}


function addPanelProcessor(){
	//connect and add with panel her ..!!!!
	$requiredData = requiredDatas();
	$request['validation'] = '3c8bc80f7202f6f924d973764a04240a';
	$groupIDs = array(); // EX: array( 0 => 1 ) // 1 should be your group ID
	$request['task'] = array('action' => 'addSite', 
		'args' => array(
			'params' => array('URL' => $requiredData['notice_display_URL'], 'username' => $requiredData['username'], 'activationKey' => $requiredData['iwp_client_activate_key'], 'groupIDs' => $groupIDs)
		)
	);
	
	$res = iwp_client_helper_http_post($request);
	return $res;

}

function requiredDatas(){
	/* IWP */
	if(defined('MULTISITE') && MULTISITE == true){	
		global $blog_id;			
		$user_id_from_email = get_user_id_from_string( get_blog_option($blog_id, 'admin_email'));
		$details = get_userdata($user_id_from_email);
		$username = $details->user_login;			
	}
	else{
		$current_user = wp_get_current_user(); 
		$username = $current_user->data->user_login;
	}	

	$iwp_client_activate_key = get_option('iwp_client_activate_key');
			
	//check BWP 
	$bwp = get_option("bit51_bwps");
	$notice_display_URL=admin_url();
	if(!empty($bwp))
	{
		//$bwpArray = @unserialize($bwp);
		if($bwp['hb_enabled']==1)
		$notice_display_URL = get_option('home');
	}
	
	$notice_display_URL = rtrim($notice_display_URL, '/').'/';
	
	return array('username' => $username, 'iwp_client_activate_key' => $iwp_client_activate_key, 'notice_display_URL' => $notice_display_URL);
}

function iwp_client_helper_http_post($request) {
	
	$host = PANELURL;
	// use the WP HTTP class if it is available
	if ( function_exists( 'wp_remote_post' ) ) {
		$http_args = array(
			'body'			=> $request,
			'user-agent' => 'my site'
		);
		$panelURL = $host;
		$response = wp_remote_post($panelURL, $http_args);
		
		if ( is_wp_error( $response ) )
			return '';

		return array( 'headers' => $response['headers'], 'body' => $response['body'] );
	} 
}

function insallClientPlugin($params){
    global $wp_filesystem;
    extract($params);
    
    if (!isset($package) || empty($package))
        return array(
            'error' => '<p>No files received. Internal error.</p>'
        );
		
    if (defined('WP_INSTALLING') && file_exists(ABSPATH . '.maintenance'))
        return array(
            'error' => '<p>Site under maintanace.</p>'
        );
    
    if (!class_exists('WP_Upgrader'))
        include_once(ABSPATH . 'wp-admin/includes/class-wp-upgrader.php');
            
    $upgrader          = new WP_Upgrader($upgrader_skin);
   
    $destination       = WP_PLUGIN_DIR;
        
    foreach ($package as $package_url) {
        $key                = basename($package_url);
        $install_info[$key] = @$upgrader->run(array(
            'package' => $package_url,
            'destination' => $destination,
            'clear_destination' => $clear_destination, //Do not overwrite files.
            'clear_working' => true,
            'hook_extra' => array()
        ));
    }
    
    if ($activate) {
        if ($type == 'plugins') {
            include_once(ABSPATH . 'wp-admin/includes/plugin.php');
            $all_plugins = get_plugins();
            foreach ($all_plugins as $plugin_slug => $plugin) {
                $plugin_dir = preg_split('/\//', $plugin_slug);
                foreach ($install_info as $key => $install) {
                    if (!$install || is_wp_error($install))
                        continue;
                    if ($install['destination_name'] == $plugin_dir[0]) {
                        $install_info[$key]['activated'] = activate_plugin($plugin_slug, '', false);
                    }
                }
            }
        }
     }
     return $install_info;
}
?>